#include "StdAfx.h"
#include "WarIfWebadm.h"   // class implemented


/////////////////////////////// PUBLIC ///////////////////////////////////////

//============================= LIFECYCLE ====================================

WarIfWebadm::WarIfWebadm(war_if_server_ptr_t& fromServer) :
mServerPtr(fromServer)
{
    mRegKey.Create(mServerPtr->GetRegKey().GetRef(WAR_WINNT_REG_WEBADM));

}// WarIfWebadm


WarIfWebadm::~WarIfWebadm()
{
}// ~WarIfWebadm


//============================= OPERATORS ====================================
//============================= OPERATIONS ===================================

void WarIfWebadm::SetAddress(war_ccstr_t newHostname)
{
    WarCollector<war_registrypath_t::path_char_t> buf = newHostname;
    mRegKey.SetValue(WAR_WINNT_REG_ADDRESS, buf.GetValue());
}

void WarIfWebadm::SetAccessGroup(war_ccsysstr_t newGroup)
{
    mRegKey.SetValue(WAR_WINNT_AUTH_GROUP, war_regstr_t(newGroup));
}

void WarIfWebadm::SetEnable(bool doEnable)
{
    mRegKey.SetValue(WAR_WINNT_REG_ENABLE, doEnable);
}

void WarIfWebadm::SetIpAccessList(const WarIpAccessList& newList)
{
    mRegKey.SetValue(WAR_WINNT_REG_IP_ACCESS_LIST_MODE, newList.mMode);

    war_regstr_t ip_list_str;
    newList.GetStrList(ip_list_str);

    mRegKey.SetValue(WAR_WINNT_REG_IP_ACCESS_LIST, ip_list_str);
}

//============================= CALLBACK   ===================================
//============================= ACCESS     ===================================
//============================= INQUIRY    ===================================

std::string WarIfWebadm::GetAddress() const
{
    WarCollector<char> buf = mRegKey.GetStrValue(WAR_WINNT_REG_ADDRESS);
    return buf.GetValue();
}

WarIfWebadm::string_t WarIfWebadm::GetAccessGroup() const
{
    return mRegKey.GetStrValue(WAR_WINNT_AUTH_GROUP);
}

bool WarIfWebadm::IsEnabled() const
{
    return mRegKey.GetIntValue(WAR_WINNT_REG_ENABLE) == 1;
}

void WarIfWebadm::GetIpAccessList(WarIpAccessList& returnList)
{
    returnList.SetValue((WarIpAccessList::ModeE)mRegKey.GetIntValue(
        WAR_WINNT_REG_IP_ACCESS_LIST_MODE, 0),
        mRegKey.GetStrValue(WAR_WINNT_REG_IP_ACCESS_LIST).c_str());
}


/////////////////////////////// PROTECTED  ///////////////////////////////////

/////////////////////////////// PRIVATE    ///////////////////////////////////

