#include "StdAfx.h"
#if WAR_RFC2068
#include "WarSvrProtocolHttpReply.h"   // class implemented

#ifndef WAR_SVR_PROTOCOL_HTTP_H
#   include "WarSvrProtocolHttp.h"
#endif

/////////////////////////////// PUBLIC ///////////////////////////////////////

//============================= LIFECYCLE ====================================

WarSvrProtocolHttpReply::WarSvrProtocolHttpReply()
{
    Reset();
}// WarSvrProtocolHttpReply


WarSvrProtocolHttpReply::~WarSvrProtocolHttpReply()
{
}// ~WarSvrProtocolHttpReply


//============================= OPERATORS ====================================
//============================= OPERATIONS ===================================

WarCollector<WarSvrProtocolHttpReply::type_t>& 
WarSvrProtocolHttpReply::AddEnumValue1(int enumValue)
        throw(WarException)
{
    // Prepare reply
    WarLog http_log(WARLOG_DEBUG_HTTP, "WarSvrProtocolHttpReply::AddEnumValue1()");
    
    mHeader.SetReplyCode((HttpReplyCodeE)enumValue);
    mHeader.SetContentLength(GetValue().size());
    if (!mHeader.IsSet("Content-Type"))
        mHeader.Set("Content-Type", "text/html");

    // Reply
    WarCollector<char> header_buffer;
    mHeader.GetHeaders(header_buffer);

    // Send header
    GetServer().Send(header_buffer.GetValue());

    if (http_log)
    {
        http_log << "Replying to client: " 
            << header_buffer.GetValue() 
            << war_endl;
    }

    // Send content
    GetServer().Send(GetValue());

    GetServer().FlushOut();

    return *this;
}

WarCollector<WarSvrProtocolHttpReply::type_t>& 
WarSvrProtocolHttpReply::AddEnumValue2(int enumValue)
        throw(WarException)
{
    mHeader.Set("Content-Type", "text/html");

    Add("<html>\r\n<title>Server Message</title>\r\n<body>\r\n"
        "<h2>Server Message</h2><hr>\r\n<strong>");
    Add(GetMessages()[enumValue]);
    Add("</strong>\r\n</body>\r\n</html>\r\n");
    return *this;
}

void WarSvrProtocolHttpReply::Reset()
{
    mHeader.Reset();
}

//============================= CALLBACK   ===================================
//============================= ACCESS     ===================================
//============================= INQUIRY    ===================================
/////////////////////////////// PROTECTED  ///////////////////////////////////

/////////////////////////////// PRIVATE    ///////////////////////////////////

#endif // #if WAR_RFC2068

