/** 
*/
#if WAR_RFC2068
#ifndef WAR_SVR_PROTOCOL_HTTP_REPLY_H
#define WAR_SVR_PROTOCOL_HTTP_REPLY_H

/* SYSTEM INCLUDES */


/* PROJECT INCLUDES */

#ifndef WAR_SVR_PROTOCOL_HTTP_HEADER_H
#   include "WarSvrProtocolHttpHeader.h"
#endif

#ifndef WAR_COLLECTOR_H
#   include "WarCollector.h"
#endif

#ifndef WAR_SVR_PROTOCOL_HTTP_ENUMS_H
#   include "WarSvrProtocolHttpEnums.h"
#endif

#ifndef WAR_SVR_PROTOCOL_HTTP_MSGS_H
#   include "WarSvrProtocolHttpMsgs.h"
#endif

/* LOCAL INCLUDES */


/* FORWARD REFERENCES */

class WarSvrProtocolHttp;

#ifdef __cplusplus
extern "C" 
{
#endif
/****************** BEGIN OLD STYLE C spesific ********/


/****************** END OLD STYLE C spesific **********/
#ifdef __cplusplus 
}
#endif

/****************** BEGIN C++ spesific ****************/

#ifdef __cplusplus

class WarSvrProtocolHttpReply :
public WarCollector<char>,
public WarSvrProtocolHttpEnums
{
public:
    // LIFECYCLE
    
    /**
    * Default constructor.
    */
    WarSvrProtocolHttpReply();
       
    /**
    * Destructor.
    */
    ~WarSvrProtocolHttpReply();
    
    // OPERATORS
    // OPERATIONS

    virtual WarCollector<type_t>& AddEnumValue1(int enumValue)
        throw(WarException);

    virtual WarCollector<type_t>& AddEnumValue2(int enumValue)
        throw(WarException);

    void Reset();

    // CALLBACK
    // ACCESS

    inline WarSvrProtocolHttpHeader& GetHeader()
    {
        return mHeader;
    }

    inline WarSvrProtocolHttpMsgs& GetMessages()
    {
        return mMessages;
    }

    inline WarSvrProtocolHttp& GetServer()
    {
        return *mpProtocol;
    }

    // INQUIRY

protected:
    WarSvrProtocolHttpHeader mHeader;
    WarSvrProtocolHttpMsgs mMessages;
    
private:
    friend class WarSvrProtocolHttp;
    WarSvrProtocolHttp *mpProtocol;
};

/* INLINE METHODS */

template <class charT>
WarCollector<charT>& operator << (WarCollector<charT>& o, 
    const WarSvrProtocolHttpEnums::HttpReplyCodeE v)
{
    return o.AddEnumValue1(v);
}

template <class charT>
WarCollector<charT>& operator << (WarCollector<charT>& o, 
    const WarSvrProtocolHttpEnums::HttpSvrMsgsE v)
{
    return o.AddEnumValue2(v);
}


/* EXTERNAL REFERENCES */

#endif /* __cplusplus */

/****************** END C++ spesific ******************/

#endif  /* WAR_SVR_PROTOCOL_HTTP_REPLY_H_ */
#endif // #if WAR_RFC2068
