/** This module starts and initialize the 
  * global objects needed by the server
  */

#ifndef WAR_LIB_OBJECTS_H
#define WAR_LIB_OBJECTS_H

/* SYSTEM INCLUDES */


/* PROJECT INCLUDES */

#include "WarThread.h"
#include "WarLog.h"
#include "WarLogIOStreamHandler.h"
#include "WarSvrEngine.h"
#include "WarSvrDefinitionFtp.h"
#include "WarSvrProtocolFtp.h"
#include "WarSocketEngine.h"
#include "WarSvrWin32NtEngine.h"
#include "WarFileEngine.h"
#include "WarFileDriverWin32.h"
#include "WarUserAuthWin32Nt.h"
#include "WarOs.h"
#include "WarUtf8.h"
#include "WarWin32Registry.h" 
#include "WarWin32NtService.h"
#include "WarTimer.h"
#include "WarShutdownEngine.h"
#include "WarPerfmonDef.h"
#include "WarSessionManager.h"
#include "WarPluginEngine.h"
#include "WarSocketCpsLimit.h"
#include "WarThreadEngine.h"

/* LOCAL INCLUDES */


/* FORWARD REFERENCES */



#ifdef __cplusplus
extern "C" 
{
#endif
/****************** BEGIN OLD STYLE C spesific ********/


/****************** END OLD STYLE C spesific **********/
#ifdef __cplusplus 
}
#endif

/****************** BEGIN C++ spesific ****************/

#ifdef __cplusplus

class WarLibObjects 
{
public:
    // LIFECYCLE
    
    /**
    * Default constructor.
    */
    WarLibObjects();
    
    /**
    * Destructor.
    */
    ~WarLibObjects();
    
    // OPERATORS   
    // OPERATIONS

    void Open(); // ::abort() on failure

    // CALLBACK
    // ACCESS
    // INQUIRY
    
protected:
private:
    WarOs *mpWarOs;
    WarPluginEngine *mpPluginEngineObject;
    WarThreadEngine *mpThreadEngineObject;
    WarShutdownEngine *mpShutdownEngineObject;
    WarLogEngine *mpLogEngine;
    war_timer_ptr_t mGlobalTimerObjectPtr;
    WarSessionManager *mpSessionManagerObject;
    WarFileEngine *mpFileEngineObject;
    WarSocketEngine *mpSocketEngineObject;
    WarSvrEngine *mpServerEngineObject;
    WarSocketCpsLimit *mpCpsLimitObject;
    WarSvrWin32NtEngine *mpWarSvrWin32NtEngineObject;
};

/* INLINE METHODS */

/* EXTERNAL REFERENCES */

#endif /* __cplusplus */

/****************** END C++ spesific ******************/

#endif  /* WAR_LIB_OBJECTS_H_ */

